<template>
  <div class="registration">
    <v-snackbar v-model="error_alert" color="error" :timeout="3000">
      {{ error_alert_message }}
    </v-snackbar>
    <div class="registration-header">
      <div class="container">
        <button @click="step === 1 ? $router.push({ name: 'Auth' }) : step--">
          <v-icon color="white" aria-hidden="false"> mdi-chevron-left </v-icon>
        </button>
      </div>
    </div>
    <div class="registration-content">
      <div class="container" v-if="step === 1">
        <div class="registration-content__header">
          <h3>Номер телефона</h3>
          <p>Введите номер телефона, который будет использован при входе</p>
        </div>
        <v-form
          v-model="phone_form"
          class="registration-form"
          ref="phoneForm"
          lazy-validation
          @submit.prevent="registration"
        >
          <v-text-field
            v-model="phone"
            label="Номер телефона"
            required
            variant="outlined"
            color="blue"
            :rules="phoneRules"
          />
          <div class="registration-form__actions">
            <v-btn
              color="blue"
              variant="contained-flat"
              @click="registration"
              size="large"
              :disabled="button_loader"
            >
              Войти
              <img
                v-if="button_loader"
                :src="require('../../assets/loader.svg')"
                width="12"
                alt=""
              />
            </v-btn>
          </div>
        </v-form>
      </div>
      <div class="container" v-if="step === 2">
        <div class="registration-content__header">
          <h3>Подтверждение телефона</h3>
          <p>
            Для подтверждения телефона на указанный номер поступит звонок.
            Отвечать на него не нужно
          </p>
          <img :src="require('../../assets/phone-confirm.svg')" alt="" />
          <p>Введите последние 4 цифры номера, с которого поступит звонок</p>
        </div>
        <v-form class="registration-form">
          <div class="registration-form__actions">
            <v-btn
              color="blue"
              variant="contained-flat"
              @click="registration"
              size="large"
            >
              {{ buttonText }}
            </v-btn>
          </div>
        </v-form>
      </div>
      <div class="container" v-if="step === 3">
        <div class="registration-content__header">
          <h3>Подтверждение телефона</h3>
          <p>
            Введите последние 4 цифры телефона, с которого вам поступил звонок,
            чтобы подтвердить номер
          </p>
        </div>
        <v-form
          v-model="code_form"
          class="registration-form"
          ref="codeForm"
          lazy-validation
          @submit.prevent="registration"
        >
          <v-text-field
            v-model="code"
            label="Последние 4 цифры"
            required
            variant="outlined"
            color="blue"
            :rules="codeRules"
          />
          <div class="registration-form__actions">
            <v-btn
              color="blue"
              variant="contained-flat"
              @click="registration"
              size="large"
              :disabled="button_loader"
            >
              {{ buttonText }}
              <img
                v-if="button_loader"
                :src="require('../../assets/loader.svg')"
                width="12"
                alt=""
              />
            </v-btn>
          </div>
        </v-form>
      </div>
      <div class="container" v-if="step === 4">
        <div class="registration-content__header">
          <h3>Ввод данных</h3>
        </div>
        <v-form
          v-model="data_form"
          class="registration-form"
          ref="dataForm"
          lazy-validation
          @submit.prevent="registration"
        >
          <v-text-field
            v-model="name"
            label="Имя"
            required
            variant="outlined"
            color="blue"
            :rules="[(v) => !!v || 'Обязательное поле!']"
            hide-details
          />

          <v-text-field
            v-model="birthday"
            label="Дата рождения"
            required
            variant="outlined"
            color="blue"
            :rules="birthdayRules"
            hide-details
          />

          <v-select
            :items="cities"
            v-model="city_id"
            item-title="name"
            item-value="id"
            label="Город"
            variant="outlined"
            color="blue"
            required
            :rules="[(v) => !!v || 'Обязательное поле!']"
            hide-details
          />

          <v-textarea
            filled
            variant="outlined"
            label="Описание"
            color="blue"
            rows="2"
            v-model="description"
            required
            :rules="[(v) => !!v || 'Обязательное поле!']"
            hide-details
          />

          <v-file-input
            color="blue"
            variant="outlined"
            accept="image/*"
            label="Аватарка"
            hide-details
            v-model="avatar"
            prepend-icon=""
            prepend-inner-icon="mdi-camera"
          />

          <div class="registration-form__actions">
            <v-btn
              color="blue"
              variant="contained-flat"
              @click="registration"
              size="large"
              :disabled="button_loader"
            >
              {{ buttonText }}
              <img
                v-if="button_loader"
                :src="require('../../assets/loader.svg')"
                width="12"
                alt=""
              />
            </v-btn>
          </div>
        </v-form>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import axios from "axios";
import moment from "moment";

export default {
  name: "LoginView",
  data() {
    return {
      step: 1,
      button_loader: false,
      cities: [],
      error_alert: "",
      error_alert_message: "",
      phone_form: false,
      phone: "+",
      phoneRules: [
        (v) => !!v || "Обязательное поле!",
        (v) =>
          /\(?\+[0-9]{1,3}\)? ?-?[0-9]{1,3} ?-?[0-9]{3,5} ?-?[0-9]{4}( ?-?[0-9]{3})?/.test(
            v
          ) || "Неверный формат!",
      ],
      code_form: false,
      code: "",
      codeRules: [
        (v) => !!v || "Обязательное поле!",
        (v) => v.length === 4 || "Неверный формат!",
      ],
      data_form: false,
      name: "",
      birthday: "",
      birthdayRules: [
        (v) => !!v || "Обязательное поле!",
        (v) =>
          /^(0?[1-9]|[12][0-9]|3[01])[.](0?[1-9]|1[012])[.]\d{4}$/.test(v) ||
          "Неверный формат!",
      ],
      city_id: "",
      description: "",
      avatar: "",
    };
  },
  computed: {
    buttonText() {
      switch (this.step) {
        case 2:
          return "Получить звонок";
        case 4:
          return "Завершить";
        default:
          return "Подтвердить";
      }
    },
  },
  methods: {
    ...mapActions({
      createOtpCode: "user/createOtpCode",
      loginUser: "user/loginUser",
      changeUserInformation: "user/changeUserInformation",
      setUserPhoto: "user/setUserPhoto",
      loadCities: "system/loadCities",
    }),

    registration() {
      switch (this.step) {
        case 1:
          this.$refs.phoneForm.validate().then((e) => {
            if (e.valid) {
              this.createOtpCode({ phone: this.phone })
                .then(() => {
                  this.step++;
                })
                .catch((error) => {
                  this.error_alert = true;
                  this.error_alert_message = error.response.data.message;
                });
            }
          });
          break;
        case 3:
          this.$refs.codeForm.validate().then((e) => {
            if (e.valid) {
              this.button_loader = true;
              this.loginUser({ phone: this.phone, code: this.code })
                .then((response) => {
                  this.button_loader = false;
                  if (response.data.data.user.recently_created) {
                    this.step++;
                    return;
                  }

                  this.$router.push({ name: "Feed" });
                })
                .catch((error) => {
                  this.button_loader = false;
                  this.error_alert = true;
                  this.error_alert_message = error.response.data.message;
                });
            }
          });
          break;
        case 4:
          this.$refs.dataForm.validate().then((e) => {
            if (e.valid) {
              this.button_loader = true;
              this.changeUserInformation({
                name: this.name,
                birthday: moment(this.birthday, "DD.MM.YYYY").format(
                  "YYYY-MM-DD"
                ),
                description: this.description,
                city_id: this.city_id,
              })
                .then(() => {
                  if (this.avatar) {
                    let formData = new FormData();
                    formData.append("file", this.avatar[0]);
                    this.setUserPhoto(formData)
                      .then(() => {
                        this.button_loader = false;
                        this.$router.push({ name: "Onboarding" });
                      })
                      .catch(() => {
                        this.button_loader = false;
                        this.$router.push({ name: "Onboarding" });
                      });
                    return;
                  }

                  this.button_loader = false;
                  this.$router.push({ name: "Onboarding" });
                })
                .catch(() => {
                  this.button_loader = false;
                  this.$router.push({ name: "Onboarding" });
                });
            }
          });
          break;
        default:
          this.step++;
      }
    },
  },

  mounted() {
    this.loadCities().then((response) => {
      this.cities = response.data.data;

      let self = this;
      navigator.geolocation.getCurrentPosition(
        function (position) {
          axios
            .get(
              `https://geocode-maps.yandex.ru/1.x?geocode=${position.coords.longitude},${position.coords.latitude}&apikey=ab546df8-91b4-4f94-bb42-25d8a284e9dc&format=json`
            )
            .then((response) => {
              let city =
                response.data.response.GeoObjectCollection.featureMember[0].GeoObject.description
                  .split(", ")
                  .filter(
                    (item) =>
                      self.cities.map((city) => city.name).indexOf(item) !== -1
                  )[0];
              if (city) {
                self.city_id = self.cities.find(
                  (item) => item.name === city
                ).id;
                return;
              }

              self.error_alert = true;
              self.error_alert_message = "Не удалось найти ваш город в списке!";
            })
            .catch(() => {
              self.error_alert = true;
              self.error_alert_message = "Не удалось найти ваш город в списке!";
            });
        },
        function () {
          self.error_alert = true;
          self.error_alert_message = "Не удалось определить геолокацию!";
        }
      );
    });
  },
};
</script>

<style scoped lang="scss">
.registration {
  background: url("../../assets/auth-bg.svg") no-repeat right bottom;
  display: grid;
  grid-template-rows: auto 1fr;
  grid-gap: $base-space * 8;
  &-header {
    background: $blue2;
    padding: ($base-space * 3) 0;
    > .container {
      display: grid;
      grid-template-columns: 24px 1fr 24px;
      align-items: center;
      justify-items: center;
    }
  }
  &-content {
    > .container {
      display: grid;
      grid-template-rows: auto 1fr;
      grid-gap: $base-space * 8;
      height: 100%;
    }
    &__header {
      > h3 {
        font-weight: 400;
        font-size: 24px;
        line-height: 18px;
        margin: 0 0 ($base-space * 3);
      }
      > p {
        font-style: normal;
        font-weight: 400;
        font-size: 14px;
        line-height: 18px;
      }
      > img {
        margin: ($base-space * 8) 0 ($base-space * 8);
      }
    }
  }
  &-form {
    position: relative;
    > .v-input {
      margin: 0 0 ($base-space * 4);
    }
    &__actions {
      width: 100%;
      position: absolute;
      bottom: 40px;
      left: 0;
      > button {
        width: 100%;
      }
    }
  }
}
</style>
